Attribute VB_Name = "tudl"
Option Explicit

' The numbers above the Declare statement below refer to the index where the function
' is defined in the Packager SDK documentation
' 4.1
Declare Function TUDLSetDeviceType Lib "tucp.dll" (ByVal NewDeviceType As Integer) As Long

' 4.2
Declare Function TUDLSetOption Lib "tucp.dll" (ByVal SetWhat As Integer, _
                                               ByVal ToWhat As Long, _
                                               ByVal Extra As Long) As Long

' 4.3
Declare Function TUDLGetOption Lib "tucp.dll" (ByVal GetWhat As Integer, _
                                               ByRef RetVal As Long, _
                                               ByVal Extra As Long) As Long

' 4.4
Declare Function TUDLSendData Lib "tucp.dll" (ByVal TheHandle As Long) As Long

' 4.5
Declare Function TUDLGetData Lib "tucp.dll" (ByVal TheHandle As Long) As Long

' 4.6
Declare Function TUDLGetDeviceVersion Lib "tucp.dll" (ByVal Device1ID As String, _
                                                      ByVal Dev1IDLen As Integer, _
                                                      ByVal Device2ID As String, _
                                                      ByVal Dev2IDLen As Integer) As Long

' 4.7
' For C++ only      int TUDLAddItem(AppIndex nAppIndex, BYTE bAppInstance, void* pItemStruct);

' 4.8
Declare Function TUDLAddTODItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                ByVal ItemID As Long, _
                                                ByVal TZName As String, _
                                                ByVal TZNameMax As Long, _
                                                ByVal TimeOffset As Long, _
                                                ByVal TimeZoneID As Long, _
                                                ByVal TZIndex As Long, _
                                                ByVal TFormat As Long, _
                                                ByVal DFormat As Long, _
                                                ByVal DSTObserved As Long, _
                                                ByVal IsInDST As Long, _
                                                ByVal ShowWeekNumber As Long, _
                                                ByVal StartOfWeek As Long) As Long

' 4.9
Declare Function TUDLAddChronoItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                   ByVal ItemID As Long, _
                                                   ByVal WorkoutID As Long, _
                                                   ByVal ItemType As Long, _
                                                   ByVal NumLaps As Long, _
                                                   ByVal DateTime As Date, _
                                                   ByVal LapNum As Long, _
                                                   ByVal Hour As Long, _
                                                   ByVal Minute As Long, _
                                                   ByVal Second As Long, _
                                                   ByVal Hundredth As Long) As Long

' 4.10
Declare Function TUDLAddTimerItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                  ByVal ItemID As Integer, _
                                                  ByVal Text As String, _
                                                  ByVal TextMax As Long, _
                                                  ByVal Hour As Long, _
                                                  ByVal Minute As Long, _
                                                  ByVal Second As Long, _
                                                  ByVal ActionAtEnd As Long, _
                                                  ByVal NumOfReps As Long, _
                                                  ByVal Reminder As Long) As Long

' 4.11
Declare Function TUDLAddIntTimerItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                     ByVal ItemID As Long, _
                                                     ByVal Text As String, _
                                                     ByVal TextMax As Long, _
                                                     ByVal Hour As Long, _
                                                     ByVal Minute As Long, _
                                                     ByVal Second As Long, _
                                                     ByVal ActionAtEnd As Long, _
                                                     ByVal NumOfReps As Long, _
                                                     ByVal Reminder As Long) As Long


' 4.12
Declare Function TUDLAddAlarmItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                  ByVal ItemID As Long, _
                                                  ByVal Text As String, _
                                                  ByVal TextMax As Long, _
                                                  ByVal Status As Long, _
                                                  ByVal Frequency As Long, _
                                                  ByVal Hour As Long, _
                                                  ByVal Minute As Long, _
                                                  ByVal Reserved As Date) As Long

' 4.13
Declare Function TUDLAddApptItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                 ByVal ItemID As Long, _
                                                 ByVal Text As String, _
                                                 ByVal TextMax As Long, _
                                                 ByVal StartDateTime As Date, _
                                                 ByVal Status As Long, _
                                                 ByVal Frequency As Long, _
                                                 ByVal TheReminder As Long, _
                                                 ByVal Reserved1 As Date, _
                                                 ByVal Reserved2 As Date) As Long

' 4.14
Declare Function TUDLAddNoteItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                 ByVal ItemID As Long, _
                                                 ByVal Text As String, _
                                                 ByVal TextMax As Long, _
                                                 ByVal Status As Long) As Long

' 4.15
Declare Function TUDLAddOptionItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                   ByVal NightModeEnabled As Long, _
                                                   ByVal NightModeAuto As Long, _
                                                   ByVal NightModeOnMin As Long, _
                                                   ByVal NightModeOnHour As Long, _
                                                   ByVal NightModeOffMin As Long, _
                                                   ByVal NightModeOffHour As Long, _
                                                   ByVal NightModeToggleDuration As Long, _
                                                   ByVal ChimeEnabled As Long, _
                                                   ByVal ChimeAuto As Long, _
                                                   ByVal ChimeOnHour As Long, _
                                                   ByVal ChimeOffHour As Long, _
                                                   ByVal ButtonBeepEnabled As Long, _
                                                   ByVal LastSetCharacter As Long, _
                                                   ByVal Password As String, _
                                                   ByVal PasswordMax As Long, _
                                                   ByVal App1Timeline As Long, _
                                                   ByVal App2TimeLine As Long, _
                                                   ByVal Reserved As Long) As Long

' 4.16
Declare Function TUDLAddOccasionItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                     ByVal ItemID As Long, _
                                                     ByVal Text As String, _
                                                     ByVal TextMax As Long, _
                                                     ByVal StartDateTime As Date, _
                                                     ByVal Status As Long, _
                                                     ByVal TheType As Long, _
                                                     ByVal IgnoreYear As Long, _
                                                     ByVal Reserved As Date) As Long

' 4.17
Declare Function TUDLAddContactItem Lib "tucp.dll" (ByVal AppInstnce As Long, _
                                                    ByVal ItemID As Long, _
                                                    ByVal NameText As String, _
                                                    ByVal NameTextMax As Long, _
                                                    ByVal TypeText As String, _
                                                    ByVal TypeTextMax As Long, _
                                                    ByVal PhoneText As String, _
                                                    ByVal PhoneTextMax As Long, _
                                                    ByVal Options As Long) As Long

' 4.18
Declare Function TUDLAddScheduleItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                     ByVal GroupID As Long, _
                                                     ByVal GroupText As String, _
                                                     ByVal GroupTextMax As Long, _
                                                     ByVal GroupLabel As String, _
                                                     ByVal GroupLabelMax As Long, _
                                                     ByVal TheType As Long, _
                                                     ByVal ItemID As Long, _
                                                     ByVal Text As String, _
                                                     ByVal TextMax As Long, _
                                                     ByVal DateTime As Date, _
                                                     ByVal DayOfWeek As Long) As Long

' 4.19
Declare Function TUDLAddSoundItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                  ByVal ItemID As SoundType, _
                                                  ByVal SoundsMax As Long, _
                                                  ByRef Sounds As Byte) As Long

' 4.20
' For C++ only      Declare Function TUDLGetItem Lib "tucp.dll" (ByVal nAppIndex As AppIndex, ByVal AppInstance As Byte, ByRef ItemStruct As Any, ByVal nItemtype As GetItemType) as long

' 4.21
Declare Function TUDLGetChronoItem Lib "tucp.dll" (ByVal AppInstance As Byte, _
                                                   ByRef ItemID As Integer, _
                                                   ByRef WorkoutID As Integer, _
                                                   ByRef ItemType As Byte, _
                                                   ByRef NumLaps As Byte, _
                                                   ByRef DateTime As Date, _
                                                   ByRef LapNum As Byte, _
                                                   ByRef Hour As Byte, _
                                                   ByRef Minute As Byte, _
                                                   ByRef Second As Byte, _
                                                   ByRef Hundredth As Byte, _
                                                   ByVal GetType As GetItemType) As Long

' 4.22
Declare Function TUDLGetAlarmItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                  ByRef ItemID As Long, _
                                                  ByRef Text As String, _
                                                  ByRef Status As Long, _
                                                  ByRef Frequency As Long, _
                                                  ByRef Hour As Long, _
                                                  ByRef Minute As Long, _
                                                  ByRef Reserved1 As Date, _
                                                  ByVal GetType As Long) As Long

' 4.23
Declare Function TUDLGetApptItem Lib "tucp.dll" (ByVal AppInstance As Long, _
                                                 ByRef ItemID As Long, _
                                                 ByRef Text As String, _
                                                 ByRef StartDateTime As Date, _
                                                 ByRef Status As Long, _
                                                 ByRef Frequency As Long, _
                                                 ByRef TheReminder As Long, _
                                                 ByRef Reserved1 As Date, _
                                                 ByRef Reserved2 As Date, _
                                                 ByVal GetType As Long) As Long
    
' 4.24
Declare Function TUDLGetNoteItem Lib "tucp.dll" (ByVal AppInstance As Byte, _
                                                 ByRef ItemID As Long, _
                                                 ByRef Text As String, _
                                                 ByRef Status As Long, _
                                                 ByVal GetType As GetItemType) As Long

' 4.25
Declare Function TUDLRemoveItem Lib "tucp.dll" (ByVal ApplicationIndex As AppIndex, ByVal AppInstance As Byte, ByVal ItemID As Integer) As Long

' 4.26
Declare Function TUDLRemoveAllItems Lib "tucp.dll" (ByVal ApplicationIndex As AppIndex, ByVal AppInstance As Byte) As Long

' 4.27
Declare Function TUDLRemoveAllApps Lib "tucp.dll" () As Long

' 4.28
Declare Function TUDLAddApp Lib "tucp.dll" (ByVal ApplicationIndex As AppIndex, _
                                            ByVal AppInstance As Long, _
                                            ByVal Password As Long, _
                                            ByVal ModeName As String) As Long

' 4.29
Declare Function TUDLAddAppExt Lib "tucp.dll" (ByVal ApplicationIndex As AppIndex, _
                                               ByVal AppInstance As Long, _
                                               ByVal Password As Long, _
                                               ByVal ModeName As String, _
                                               ByRef Parameters As Byte, _
                                               ByVal ParamLen As Byte, _
                                               ByRef AppCode As Byte, _
                                               ByVal Codelen As Integer, _
                                               ByRef Database As Byte, _
                                               ByVal DatabaseLen As Integer) As Long

' 4.30
Declare Function TUDLBeep Lib "tucp.dll" (ByVal Frequency As Integer, _
                                          ByVal Duration As Integer) As Long


' 4.31

Declare Function TUDLAddPeriodicTask Lib "tucp.dll" (ByVal Codelen As Integer, _
                                                     ByRef PerCode As Byte) As Long
                                                    

''''''''''''''''''''''''''''''''''''''''''''''''''''''
' ENUMERATIONS
''''''''''''''''''''''''''''''''''''''''''''''''''''''

Global Const DL_DEV_851 = 1

''''''''''''''''''''''''''''''''''''''''''''''''''''''
' TOD

Enum DateFormat
    DMY = 0         ' dd.mm.yy
    YMD = 1         ' yy-mm-dd
    MDY = 2         ' mm-dd-yy
End Enum

Enum TimeFormat
    HOUR12 = 0      ' am/pm time
    HOUR24 = 1      ' everybody else's time
End Enum

Enum TimeZoneIndex
    TZ_GMT = 0
    TZ_1 = 1
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Chrono

Enum ChronoFormat
    CHRONOFORMAT_LAP_SPLIT = 0
    CHRONOFORMAT_SPLIT_LAP = 1
    CHRONOFORMAT_TIME_SPLIT = 2
    CHRONOFORMAT_TIME_LAP = 3
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Timer

Enum TimerAction
    TIMERACTION_STOP = 0
    TIMERACTION_REPEAT = 1
    TIMERACTION_CHRONO = 2
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Alarm

Enum AlarmStatus
    ALM_UNUSED = 0
    ALM_DISARMED = 1
    ALM_ARMED = 3
End Enum

Enum AlarmFrequency
    ALMFREQ_DAILY = 1
    ALMFREQ_WEEKDAY = 2
    ALMFREQ_WEEKEND = 3
    ALMFREQ_WEEKLY_SU = 4
    ALMFREQ_WEEKLY_MO = 5
    ALMFREQ_WEEKLY_TU = 6
    ALMFREQ_WEEKLY_WE = 7
    ALMFREQ_WEEKLY_TH = 8
    ALMFREQ_WEEKLY_FR = 9
    ALMFREQ_WEEKLY_SA = 10
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Appointment

Enum ApptStatus
    APPT_UNUSED = 0
    APPT_DISARMED = 1
    APPT_ARMED = 3
End Enum

Enum ApptFrequency
    APPTFREQ_1DAY = 0
    APPTFREQ_DAILY = 1
    APPTFREQ_WEEKDAY = 2
    APPTFREQ_WEEKEND = 3
    APPTFREQ_WEEKLY = 11
    APPTFREQ_MONTHLY = 12
    APPTFREQ_YEARLY = 13
End Enum

Enum Reminder
    REMINDER_0MINS = 0
    REMINDER_5MINS = 1
    REMINDER_10MINS = 2
    REMINDER_15MINS = 3
    REMINDER_30MINS = 4
    REMINDER_60MINS = 5
    REMINDER_2HRS = 6
    REMINDER_3HRS = 7
    REMINDER_4HRS = 8
    REMINDER_5HRS = 9
    REMINDER_6HRS = 10
    REMINDER_8HRS = 11
    REMINDER_10HRS = 12
    REMINDER_12HRS = 13
    REMINDER_24HRS = 14
    REMINDER_48HRS = 15
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Occasion

Enum OccasionType
    OCCASION_NONE = 0
    OCCASION_BDAY = 1
    OCCASION_ANNIV = 2
    OCCASION_HOLIDAY = 3
    OCCASION_VACATION = 4
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Schedule

Enum ScheduleType
    SCHEDULE_DATE = 1
    SCHEDULE_DOW_TIME = 2
    SCHEDULE_DATETIME = 3
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Sounds

Enum SoundType
    SOUND_BUTTON_BEEP = 0
    SOUND_HOURLY_CHIME = 1
    SOUND_ALARM = 2
    SOUND_APPOINTMENT = 3
    SOUND_TIMER = 4
    SOUND_INT_TIMER = 5
    SOUND_HALF_TIMER = 6
    SOUND_COMM_ERROR = 7
    SOUND_CUSTOM = 8
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Application Types Enumeration

Enum AppIndex
    TOD_APP = 0
    COMM_APP = 1
    CHRONO_APP = 2
    TIMER_APP = 3
    INTTIMER_APP = 4
    ALARM_APP = 5
    APPT_APP = 6
    NOTE_APP = 7
    OPTION_APP = 8
    OCCASION_APP = 9
    CONTACT_APP = 10
    SCHEDULE_APP = 11
    SYNCHRO_APP = 12
    COUNTER_APP = 13
    SOUND_APP = 16
    WRISTAPP_APP = 17
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Get Item Enumeration

Enum GetItemType
    GETITEM_FIRST = 0
    GETITEM_NEXT = 1
    GETITEM_FIRST_MODIFIED = 2
    GETITEM_NEXT_MODIFIED = 3
End Enum

'////////////////////////////////////////////////////////////////////
' Options for TUDLGetOption and TUDLSetOption API functions.


Global Const DL_OPT_DEV_APPT_LEN = 1   ' Returns max allowable length of appointment
                                       ' messages for the selected device.
                                       ' This is typically 100 characters.

Global Const DL_OPT_DEV_NOTE_LEN = 2   ' Returns max allowable length of note item
                                       ' messages for the selected receiver / device.

Global Const DL_OPT_DEV_PHONE_LEN = 3  ' Returns max allowable length of phone
                                       ' messages (name) for the selected receiver / device.

Global Const DL_OPT_DEV_PHONE_NUM_LEN = 4  ' Returns max allowable length of phone book
                                           ' numbers for the selected receiver / device.
                                           ' This is typically 12 characters.

Global Const DL_OPT_DEV_OCC_LEN = 5   ' Returns max allowable length of occasion
                                      ' messages for the selected receiver / device.

Global Const DL_OPT_DEV_ALARM_LEN = 6  ' Returns max allowable length of alarm
                                       ' messages for the selected receiver / device.

Global Const DL_OPT_DEV_CITY_LEN = 7   ' Returns max allowable length of city code
                                       ' messages for the selected receiver / device.
                                       ' This is typically 3 characters.

Global Const DL_OPT_DEV_MAX_PACKET_LEN = 8   ' Returns max allowable packet length for
                                             ' the selected receiver / device.
                                             ' This ID is for internal use only, and
                                             ' should not be used by application
                                             ' developers.

Global Const DL_OPT_DEV_TOD_MAX = 9    ' Returns max number of Time Of Day zones supported by
                                       ' the selected device

Global Const DL_OPT_SYS_DEVICE = 10    ' Returns the currently-selected device type.
                                       ' For example, DL_DEV_851
                                       '
                                       ' Use the SetDeviceType() API to set a new device type.

Global Const DL_OPT_DEV_MAX_DATABASE = 12  ' Returns the max size of database information for
                                           ' the selected receiver / device.
                                           '
                                           ' The database consists of all application entries.
                                           ' The database is a single block
                                           ' in most devices; this means that these
                                           ' info types are combined into a single
                                           ' structure, which is downloaded as a unit.
                                           ' It is therefore impossible to update a
                                           ' device's phonebook yet leave the appointments
                                           ' unaffected.
                                           '
                                           ' A PIM / front-end app can typically accept
                                           ' more information than can be stored in a device.
                                           ' This ID is therefore used to control the amount
                                           ' of database data to be downloaded.  This is
                                           ' accomplished by adding all the database,
                                           ' request the max allowable database size using
                                           ' this ID, then request the current total database
                                           ' size using the DL_OPT_DEV_TOTAL_DATA identifier
                                           ' (described next).  A warning should be displayed
                                           ' once the total exceeds the max, and actual
                                           ' download must be inhibited until the total is
                                           ' less than or equal to the max allowable.
                                                    
Global Const DL_OPT_DEV_TOTAL_DATA = 13    ' Returns the current size of the database information
                                           ' structure for the selected receiver / device.
                                           '
                                           ' This value may exceed the maximum allowable database
                                           ' size for the selected device.  It is therefore required
                                           ' that this value be compared to the value returned using
                                           ' the DL_OPT_DEV_MAX_DATABASE identified (described above).
                                           ' The actual download must be inhibited until the current
                                           ' database structure size is less or equal to the max
                                           ' allowable.

Global Const DL_OPT_DEV_TOTAL_USER_MEMORY = 14   ' Returns a value specifying percentage of the memory
                                                 ' used by currently selected data for the current device.
                                                 '
                                                 ' This parameter can be used in place of the previous two
                                                 ' to show the percentage of memory used.

Global Const DL_OPT_DEV_MAX_APPS = 15      ' Returns a value specifying the maximum number of
                                                                                   ' applications (modes). Time of day mode and communication
                                                                                   ' mode are excluded from this value.

Global Const DL_OPT_DEV_MAX_PROGRAM = 27    ' Returns the max size of downloadable program area for
                                            ' the selected receiver / device.
                                            '
                                            ' Downloadable programs are small programs which can be
                                            ' downloaded to the device using Timex Data Link.
                                            '
                                            ' The value returned is the memory size allocated by
                                            ' the device to store the downloadable program (in bytes).
                                            '
                                            ' Use the DL_DEV_SUP_PROGRAM identifier with
                                            ' TUDLGetOption to determine if the selected
                                            ' device supports downloadable programs.

Global Const DL_OPT_DEV_MAX_MELODY = 28     ' Returns the max size of downloadable melody area
                                            ' for the selected receiver / device.
                                            '
                                            ' Downloadable melodies are small sound-scapes
                                            ' which can be downloaded to the device using Timex Data
                                            ' Link.
                                            '
                                            ' The value returned is the memory size allocated by
                                            ' the device to store the downloadable melody (in bytes).
                                            '
                                            ' Use the DL_DEV_SUP_MELODY identifier with
                                            ' TUDLGetOption to determine if the selected
                                            ' device supports downloadable melody info.

Global Const DL_OPT_DEV_TIMER_MAX = 29   ' Returns max number of timer entries supported by
                                         ' the selected receiver

Global Const DL_OPT_DEV_INTTIMER_MAX = 30    ' Returns max number of interval timer entries
                                             ' supported by the selected receiver

Global Const DL_OPT_DEV_SCHEDULE_MAX = 31    ' Returns max number of schedule entries
                                             ' supported by the selected receiver

Global Const DL_OPT_DEV_SCHEDULE_GROUP_MAX = 32  ' Returns max number of schedule groups
                                                 ' supported by the selected receiver

Global Const DL_OPT_DEV_SCHEDULE_GROUP_NAME_LEN = 33  ' Returns max length of the group name
                                                      ' This is a label for the schedule mode set position
                                                      ' such as "LOCATION" or "TEAM"

Global Const DL_OPT_DEV_SCHEDULE_NUM = 34    ' Returns current number of schedule entries

Global Const DL_OPT_DEV_INTTIMER_NUM = 35    ' Returns current number of interval timer

Global Const DL_OPT_DEV_TIMER_NUM = 36       ' Returns current number of timer

Global Const DL_OPT_DEV_ALARM_NUM = 37       ' Returns current number of alarms

Global Const DL_OPT_SYS_ERR_CODE = 38        ' Returns the specific error code for the most recent
                                             ' API call.
                                             '
                                             ' With few exceptions, all API functions return a value
                                             ' of 0 for success, a value less than 0 for an error
                                             ' and a value greater than 0 for a warning.  Most often,
                                             ' it is sufficient to simply test the return value and
                                             ' if an error then cancel current operation and shut-down,
                                             ' and if a warning then just continue on knowing that a
                                             ' non-critical error occurred.

Global Const DL_OPT_DEV_SUP_PROGRAM = 45     ' Returns a boolean value indicating the support for
                                             ' downloadable programs for the selected receiver / device.

Global Const DL_OPT_DEV_SUP_MELODY = 46      ' Returns a boolean value indicating the support for
                                             ' downloadable melody information for the selected
                                             ' receiver / device.

Global Const DL_OPT_DEV_SUP_SYSTEM_DATA = 47   ' Returns a boolean value indicating the support for
                                               ' downloadable system information for the selected
                                               ' receiver / device.
                                               '
                                               ' System information consists of settings such as
                                               ' hourly chime control and keypress beeps on the
                                               ' device.

Global Const DL_OPT_DEV_SUP_INTL_DATE_FORMAT = 48   ' Returns a boolean value indicating the support for
                                                    ' international date formats for the selected
                                                    ' receiver / device.
                                                    '
                                                    ' International date formats allow the device to display
                                                    ' date information in MMDDYY, YYMMDD and DDMMYY ordering,
                                                    ' using "." or "-" characters as seperators.

Global Const DL_OPT_SYS_NUM_DEVICES = 49        ' Returns the number of device types
                                                ' the system is aware of.

Global Const DL_OPT_DEV_APPT_NUM = 50           ' Returns current number of appointments

Global Const DL_OPT_DEV_NOTE_NUM = 51           ' Returns current number of note entries

Global Const DL_OPT_DEV_PHONE_NUM = 52          ' Returns current number of phone numbers
                                         
Global Const DL_OPT_DEV_OCC_NUM = 53      ' Returns current number of anniversaries

Global Const DL_OPT_DEV_ALARM_MAX = 54    ' Returns max number of alarms supported by the device

Global Const DL_OPT_DEV_APPT_MAX = 55     ' Returns max number of appointments supported by
                                          ' the selected receiver / device.

Global Const DL_OPT_DEV_NOTE_MAX = 56      ' Returns max number of note entries supported by
                                           ' the selected receiver / device.

Global Const DL_OPT_DEV_PHONE_MAX = 57      ' Returns max number of phone numbers supported by
                                            ' the selected receiver / device.

Global Const DL_OPT_DEV_OCC_MAX = 58       ' Returns max number of occasions supported by
                                           ' the selected receiver / device.

Global Const DL_OPT_DEV_TIMER_LEN = 60      ' Returns max allowable length of timer
                                            ' messages for the selected receiver / device.

Global Const DL_OPT_DEV_CHRONO_NAME_LEN = 61    ' Returns max allowable length of chrono name.

Global Const DL_OPT_DEV_CHRONO_NUM = 62      ' Returns or sets current number of chrono laps.

Global Const DL_OPT_DEV_CHRONO_MAX = 63      ' Returns max allowable number of chrono laps.

Global Const DL_OPT_DEV_SUP_CHRONO = 64      ' Returns a boolean value indicating the support
                                             ' for configurable/controllable chronographs for
                                             ' the selected receiver / device.
                                             '
                                             ' Controllable chronos allow a user to configure
                                             ' the chrono embedded in the receiver.  Options
                                             ' such as number of laps of storage are set.

Global Const DL_OPT_DEV_SUP_TIMER = 65       ' Returns a boolean value indicating the support
                                             ' for configurable/controllable timers for
                                             ' the selected receiver / device.
                                             '
                                             ' Controllable timers allow a user to configure
                                             ' the timer embedded in the receiver.  Options
                                             ' such as timeout duration are set.

Global Const DL_OPT_DEV_SUP_DATABASE = 68    ' Returns a boolean value indicating the support
                                             ' for any or all the database types (appointments,
                                             ' anniversaries, phone books and to-do lists)
                                             ' for the selected receiver / device.
                                             '
                                             ' Databases allow storage of the 4 information
                                             ' types outlined above.  Most devices will
                                             ' support all the database types, but some will
                                             ' only support a subset of the database types.

Global Const DL_OPT_DEV_CHRONO_MIN = 71      ' Returns min allowable number of chrono laps.

Global Const DL_OPT_DEV_CHRONO_FORMAT = 72   ' Sets or returns chrono display format which can
                                             ' be one of the ChronoFormat enum types


Global Const DL_OPT_DEV_SUP_NIGHTMODE_OPT = 73  ' Returns a boolean value indicating the support
                                                ' for setting Night-Mode options.
                                                                                                
'////////////////////////////////////////////////////////////////////
'Error Codes

Global Const TIMEX_SUCCESS = 0
Global Const TIMEX_ERR_TOO_MUCH_DATA = 3
Global Const TIMEX_ERR_NO_MEM = 4
Global Const TIMEX_ERR_FILE_ERR = 7
Global Const TIMEX_ERR_INV_PACKET_LEN = 8
Global Const TIMEX_ERR_INV_PARM = 9
Global Const TIMEX_ERR_DEV_NOT_FOUND = 10
Global Const TIMEX_ERR_COMM = 11
Global Const TIMEX_ERR_COMM_CHECKSUM = 12
Global Const TIMEX_ERR_COMM_PACKET_LEN = 13
Global Const TIMEX_ERR_COMM_DEV_INFO = 14
Global Const TIMEX_ERR_COMM_DEV_MISMATCH = 15
Global Const TIMEX_ERR_COMM_TIMEOUT = 16
Global Const TIMEX_ERR_NO_ITEM = 18
Global Const TIMEX_READ_FILE_TIMEOUT = 19
Global Const TIMEX_ERR_DEV_API_MISMATCH = 27
Global Const TIMEX_ERR_PROG_EXISTS = 30
Global Const TIMEX_ERR_ITEM_EXISTS = 32
Global Const TIMEX_ERR_BAD_CHAR_IN_PROG = 33
Global Const TIMEX_ERR_INVALID_DEVICE = 34
Global Const TIMEX_ERR_PROGRAM_TOO_LARGE = 46
Global Const TIMEX_ERR_MELODY_TOO_LARGE = 47
Global Const TIMEX_ERR_TOO_MUCH_BINARY_DATA = 48
Global Const TIMEX_ERR_COMM_LOST_SUSPEND_MODE = 49
Global Const TIMEX_WRN_OVER_MAXDATA = -1
Global Const TIMEX_WRN_TEXT_TRUNCATED = -2
Global Const TIMEX_WRN_CHAR_LOST = -3
Global Const TIMEX_WRN_NO_DATA = -5
Global Const TIMEX_WRN_DEFAULT_DEV_SET = -6
Global Const TIMEX_WRN_USER_ABORT = -8
Global Const TIMEX_WRN_TOO_MANY_RECORDS = -9
Global Const TIMEX_WRN_NUMBER_ADJUSTED = -10
Global Const TIMEX_WRN_NOT_LAST_DEVICE = -11
